/*****************************************************************************
**
**  clsf_mgr.c
**
**  Description:
**     Contains Unigraphics entry points for the application.
**
*****************************************************************************/

/*  Include files */
#include <stdio.h>
#include <string.h>
#include <uf.h>
#include <uf_ui.h>
#include "clsf_mgr.h"

#include <windows.h>

typedef UINT (CALLBACK* LPFNDLLFUNC1)(); //char *

LPFNDLLFUNC1 lpfnDllFunc1;    // Function pointer

/*****************************************************************************
**  Activation Methods
*****************************************************************************/

/*  Explicit Activation
**      This entry point is used to activate the application explicitly, as in
**      "File->Execute UG/Open->User Function..." */
extern DllExport void ufusr( char *parm, int *returnCode, int rlen )
{
    char * release; // 
    char name[30], mes[128]; //   +  
    int i ;
    HMODULE hLib1;
    //HMODULE hmodule;

    /* Initialize the API environment */
    int errorCode = UF_initialize();

    if ( 0 == errorCode )
    {
        /* TODO: Add your application code here */

	// libcams.dll
	// libcamsint.dll - 18,nx1
	// libcamsutilint.dll - nx2
	// libcamsutil1.dll    libcamsutil2.dll
	// libcamsmom.dll
	// libcamsobj.dll
	// libcamsproc1.dll
	// libcamsproc2.dll
	// libcamsscop.dll
	// libcamssimint.dll  libcamssim.dll

	//  
	// ....
	// UI_MOM_DBG__create_dialog UI_MOM_create_directory UI_MOM_create_doc_dialog UI_MOM_get_default_file - 
	// UI_OPER__......  
	// UI_PARAM__......  
	// ....
	// UI_CLSF_clsf_mgr UI_CLSF_display UI_CLSF_display_path UI_CLSF_init
	// UI_CLSF_init_file UI_CLSF_list UI_CLSF_list_path UI_CLSF_open UI_CLSF_query_save
	// UI_CLSF_rename UI_CLSF_save UI_CLSF_save_as UI_CLSF_set_mgr_active
	// UI_CLSF_specify_existing UI_CLSF_specify_export
	// UI_CLSF__add_to_list_at_pos UI_CLSF__clear_paste UI_CLSF__clsf_display UI_CLSF__clsf_edit
	// UI_CLSF__clsf_optimize UI_CLSF__clsf_postprocess UI_CLSF__clsf_resequence
	// UI_CLSF__filter UI_CLSF__toolpath_blank UI_CLSF__toolpath_cut UI_CLSF__toolpath_delete
	// UI_CLSF__toolpath_display UI_CLSF__toolpath_list UI_CLSF__toolpath_paste UI_CLSF__toolpath_unblank
	// UI_CLSF__warn UI_CLSF_ask_mgr_active UI_CLSF_close

	//UF_UI_open_listing_window();

	UF_get_release ( &release );
	//mes[0]='\0'; sprintf(mes,"\n  Unigraphics - %s ",release); UF_UI_write_listing_window(mes);

	name[0]='\0';
	if (strstr(release,"V18") || strstr(release,"NX V1")) sprintf(name,"libcamsint.dll");
	else sprintf(name,"libcamsutilint.dll");

	//UF_free ( release );

	// UF_UI_write_listing_window("\n   : ");
	//mes[0]='\0';
	//hmodule=GetModuleHandle(NULL);
	//GetModuleFileName( hmodule , mes , sizeof(mes) );
	// UF_UI_write_listing_window(mes); UF_UI_write_listing_window("\n");

	hLib1=LoadLibrary(name); // libcamsutilint.dll  libcamsint.dll
        if (hLib1 != NULL )
	{
         lpfnDllFunc1 = (LPFNDLLFUNC1)GetProcAddress(hLib1,"UI_CLSF_clsf_mgr");
         if (!lpfnDllFunc1)
	 {
           // handle the error
           mes[0]='\0'; sprintf(mes,"     - %s \n   UG","UI_CLSF_clsf_mgr");
  	   uc1601 (mes, 1 );
	 } else {
           // call the function
	   i=lpfnDllFunc1();
	 }
         FreeLibrary(hLib1);
	} else {
	  mes[0]='\0'; sprintf(mes,"   - %s ",name);
	  uc1601 (mes, 1 );
	}

	 /* Terminate the API environment */
        errorCode = UF_terminate();
    }

    /* Print out any error messages */
    PrintErrorMessage( errorCode );
    *returnCode=0;
}
/*****************************************************************************
**  Utilities
*****************************************************************************/

/* Unload Handler
**     This function specifies when to unload your application from Unigraphics.
**     If your application registers a callback (from a MenuScript item or a
**     User Defined Object for example), this function MUST return
**     "UF_UNLOAD_UG_TERMINATE". */
extern int ufusr_ask_unload( void )
{
    return( UF_UNLOAD_IMMEDIATELY );
}

/* PrintErrorMessage
**
**     Prints error messages to standard error and the Unigraphics status
**     line. */
static void PrintErrorMessage( int errorCode )
{
    if ( 0 != errorCode )
    {
        /* Retrieve the associated error message */
        char message[133];
        UF_get_fail_message( errorCode, message );

        /* Print out the message */
        UF_UI_set_status( message );

        fprintf( stderr, "%s\n", message );
    }
}
